
#include <windows.h>
//#include <stdio.h>
#include "classparser.h"



char* commands[256] = 
{
"nop","aconst_null","iconst_m1","iconst_0","iconst_1","iconst_2","iconst_3","iconst_4","iconst_5","lconst_0","lconst_1","fconst_0","fconst_1","fconst_2","dconst_0","dconst_1",
"bipush","sipush","ldc","ldc_w","ldc2_w","iload","lload","fload","dload","aload","iload_0","iload_1","iload_2","iload_3","lload_0","lload_1",
"lload_2","lload_3","fload_0","fload_1","fload_2","fload_3","dload_0","dload_1","dload_2","dload_3","aload_0","aload_1","aload_2","aload_3","iaload","laload",
"faload","daload","aaload","baload","caload","saload","istore","lstore","fstore","dstore","astore","istore_0","istore_1","istore_2","istore_3","lstore_0",
"lstore_1","lstore_2","lstore_3","fstore_0","fstore_1","fstore_2","fstore_3","dstore_0","dstore_1","dstore_2","dstore_3","astore_0","astore_1","astore_2","astore_3","iastore",
"lastore","fastore","dastore","aastore","bastore","castore","sastore","pop","pop2","dup","dup_x1","dup_x2","dup2","dup2_x1","dup2_x2","swap",
"iadd","ladd","fadd","dadd","isub","lsub","fsub","dsub","imul","lmul","fmul","dmul","idiv","ldiv","fdiv","ddiv",
"irem","lrem","frem","drem","ineg","lneg","fneg","dneg","ishl","lshl","ishr","lshr","iushr","lushr","iand","land",
"ior","lor","ixor","lxor","iinc","i2l","i2f","i2d","l2i","l2f","l2d","f2i","f2l","f2d","d2i","d2l",
"d2f","i2b","i2c","i2s","lcmp","fcmpl","fcmpg","dcmpl","dcmpg","ifeq","ifne","iflt","ifge","ifgt","ifle","if_icmpeq",
"if_icmpne","if_icmplt","if_icmpge","if_icmpgt","if_icmple","if_acmpeq","if_acmpne","goto","jsr","ret","tableswitch","lookupswitch","ireturn","lreturn","freturn","dreturn",
"areturn","return","getstatic","putstatic","getfield","putfield","invokevirtual","invokespecial","invokestatic","invokeinterface",0,"new","newarray","anewarray","arraylength","athrow",
"checkcast","instanceof","monitorenter","monitorexit","wide","multianewarray","ifnull","ifnonnull","goto_w","jsr_w",0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
};


char operands[256] = 
{
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,2,1,2,2,1,1,1,1,1,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,
2,2,2,2,2,2,2,2,2,1,-1,-1,0,0,0,0,
0,0,2,2,2,2,2,2,2,4,0,2,1,2,0,0,
2,2,0,0,-1,3,2,2,4,4,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
};

extern HANDLE heap;

char* processAttributes(struct classfile* str, attribute_info* attr, int attr_count,char* s,int slen, int func, unsigned int param);
unsigned __int64* processCode(unsigned char* code, unsigned int len, int func, int param);
void addUTF8Constant(struct classfile* str, unsigned char* value, int len);
void correctMethodRef(struct classfile* str, int method_index, int const_index);
int CompareMemory (
        const void * buf1,
		size_t count1,
        const void * buf2,
        size_t count2
        );

/*
anewarray(0xbd), checkcast(0xc0), getfield(0xb4), getstatic(0xb2), instanceof(0xc1), invokeinterface(0xb9), invokespecial(0xb7), 
invokestatic(0xb8), invokevirtual(0xb6),
ldc(0x12), ldc_w(0x13), ldc2_w(0x14), multianewarray(0xc5), new(0xbb), putfield(0xb5), putstatic(0xb3) 
*/


void splitMethods(struct classfile* str)
{
	char buff[10];

	struct mname{
		int count;
		int len;
		unsigned char* name;
	};

	struct mname* m = (struct mname*)HeapAlloc(heap,0,str->methods_count*sizeof(mname));
	int mlen=0;

	for(int i=0;i<str->methods_count;i++){
		cp_info* cp = &str->constant_pool[str->methods[i].name_index];		

		bool found = false;
		for(int j=0;j<mlen;j++){
			
			if(!CompareMemory(m[j].name,m[j].len,cp->value1.string,cp->value.u2)){
				int len = cp->value.u2+5+(int)(m[j].count/10);
				unsigned char* c = (unsigned char*)HeapAlloc(heap,0,len);
				wsprintf(buff,"_$$%d",m[j].count);
				CopyMemory(c,cp->value1.string,cp->value.u2);
				lstrcpy((char*)(c+cp->value.u2),buff);

				addUTF8Constant(str, c, len-1);
				correctMethodRef(str,i,str->constant_pool_count-1);

				str->methods[i].name_index = str->constant_pool_count-1; 

				HeapFree(heap,0,c);
				m[j].count++;
				found=true;
			}

		}

		if(!found){
			m[mlen].count=0;
			m[mlen].len=cp->value.u2;    
			m[mlen].name=cp->value1.string;  
			mlen++;
		}


	}


}


void addUTF8Constant(struct classfile* str, unsigned char* value, int len)
{
	cp_info cp;
	cp.tag = CONSTANT_Utf8;
	cp.value.u2 = len;
	cp.value1.string = (unsigned char*)HeapAlloc(heap,0,len);
	CopyMemory(cp.value1.string,value,len);

	str->constant_pool_count++; 
	str->constant_pool = (struct cp_info*)HeapReAlloc(heap,0,str->constant_pool,(str->constant_pool_count)*sizeof(cp_info));
	str->constant_pool[str->constant_pool_count-1]=cp;

}


void correctMethodRef(struct classfile* str, int method_index, int const_index)
{
	cp_info* cp = &str->constant_pool[str->methods[method_index].name_index]; 
	unsigned char* methname = cp->value1.string;   
	int methlen = cp->value.u2; 
	cp = &str->constant_pool[str->methods[method_index].descriptor_index]; 
	unsigned char* methdescr = cp->value1.string;   
	int descrlen = cp->value.u2; 
	cp = &str->constant_pool[str->constant_pool[str->this_class].value.u2]; 
	unsigned char* classname = cp->value1.string;   
	int classlen = cp->value.u2; 


	
	cp_info* cp1;
	for(int i=0;i<str->constant_pool_count;i++){
		cp = &str->constant_pool[i]; 
		if(cp->tag == CONSTANT_Methodref){

			// class
			cp1=&str->constant_pool[str->constant_pool[cp->value.u2].value.u2];
			if(!CompareMemory(cp1->value1.string,cp1->value.u2,classname,classlen)){
				
				// name
				cp1=&str->constant_pool[str->constant_pool[cp->value1.u2].value.u2];
				if(!CompareMemory(cp1->value1.string,cp1->value.u2,methname,methlen)){
					
					// descriptor
					cp1=&str->constant_pool[str->constant_pool[cp->value1.u2].value1.u2];
					if(!CompareMemory(cp1->value1.string,cp1->value.u2,methdescr,descrlen)){
						str->constant_pool[cp->value1.u2].value.u2 = const_index; 
						return;
					}
				}
			}
		}
	}


}


int getUTF8ConstantByValue(struct classfile* str, unsigned char* value, int len){

	for(int i=0;i<str->constant_pool_count;i++){
		cp_info* cp=&str->constant_pool[i];
		if(cp->tag == CONSTANT_Utf8){
			if(!CompareMemory(value,len,cp->value1.string,cp->value1.u2)){
				return i;	
			}
		}
	}

	return -1;
}


void restoreMethod(struct classfile* str, int index, int truelen)
{

	int utfindex = str->methods[index].name_index;
	unsigned char* c = str->constant_pool[utfindex].value1.string;

	int utfcindex = getUTF8ConstantByValue(str,c,truelen);
	if(utfcindex==-1){
		addUTF8Constant(str, c, truelen);
		utfcindex=str->constant_pool_count; 
	}
	str->methods[index].name_index = utfcindex;
	correctMethodRef(str, index, utfcindex);

	int ret;
	deleteConstant(str,utfindex, &ret);

}


void restoreMethods(struct classfile* str)
{

	for(int i=0;i<str->methods_count;i++){
		cp_info* cp = &(str->constant_pool[str->methods[i].name_index]); 
		unsigned char* c = cp->value1.string + (cp->value.u2 - 1);  
		
		for(int j=cp->value.u2-1;j>=0;j--){
			unsigned char cc = *c;
			if(cc=='$' && cp->value.u2-j>1){
				if(j>=3 && *(--c)=='$'){
					if(*(--c)=='_'){
						restoreMethod(str,i,j-2);
						break;
					}
				}
			}
			if(cc<'0' || cc>'9')break;
			c--;
		}
	}
}



char* deleteConstant(struct classfile* str, unsigned long index, int* res)
{

	if(index>=str->constant_pool_count){
		char* c = (char*)HeapAlloc(heap,0,96);
		lstrcpy(c,"Selected constant not found in constant pool. If you have recently added it, save your changes.");
		*res=1;
		return c;
	}
	*res=0;
	char* c = processClassStruct(str, 1, index);
	if(!c){
		processClassStruct(str, 2, index);

		cp_info* cp = &(str->constant_pool[index]);
		if(cp->tag==CONSTANT_Utf8 && cp->value.u2>0){ 
			HeapFree(heap,0,cp->value1.string);
		}
		
		int offset=((cp->tag==CONSTANT_Long || cp->tag==CONSTANT_Double)?2:1);

		for(int i=index;i<str->constant_pool_count-offset;i++){
			str->constant_pool[i]=str->constant_pool[i+offset];
		}

		str->constant_pool_count-=offset;
	
	}
	return c;
}


/*
func:	1 - search for references, param - const. index
		2 - subtract 1 from all constants with indexes g.t. param
*/
char* processClassStruct(struct classfile* str, int func, int param)
{

	char buff[1024];
	int i;

	char*  res = 0;
	if(func==1)res=(char*)HeapAlloc(heap,HEAP_ZERO_MEMORY,1);
	int reslen=1;
	
	// header
	if(func==1){
		if(str->this_class==param){
			reslen+=19;
			res=(char*)HeapReAlloc(heap,0,res,reslen);
			lstrcat(res,"Header: this_class\n");
		}
		if(str->super_class==param){
			reslen+=20;
			res=(char*)HeapReAlloc(heap,0,res,reslen);
			lstrcat(res,"Header: super_class\n");
		}
	}else{
		if(str->this_class>param)str->this_class--; 
		if(str->super_class>param)str->this_class--; 
	}

	// constant pool
	for(i=1;i<str->constant_pool_count;i++){
		cp_info* cp=&(str->constant_pool[i]); 
		
		switch(cp->tag){
		case CONSTANT_Class:
		case CONSTANT_String:
			if(func==1){
				if(cp->value.u2==param){
					reslen+=28;
					res=(char*)HeapReAlloc(heap,0,res,reslen);
					lstrcat(res,"Constant: ");
					wsprintf(buff,"%0.4lX",i);
					lstrcat(res,buff);
					lstrcat(res," Type: ");
					lstrcat(res,(cp->tag==7)?"Class \n":"String\n");
				}
			} else {
				if(cp->value.u2>param)cp->value.u2--;
			}
			break;
		case CONSTANT_Fieldref:
		case CONSTANT_Methodref:
		case CONSTANT_InterfaceMethodref:
		case CONSTANT_NameAndType:
			if(func==1){
				if(cp->value.u2==param || cp->value1.u2==param){
					reslen+=40;
					res=(char*)HeapReAlloc(heap,0,res,reslen);
					lstrcat(res,"Constant: ");
					wsprintf(buff,"%0.4lX",i);
					lstrcat(res,buff);
					lstrcat(res," Type: ");
					char* c;
					switch(cp->tag){
						case CONSTANT_Fieldref:
							c="Fieldref          \n";
							break;
						case CONSTANT_Methodref:
							c="Methodref         \n";
							break;
						case CONSTANT_InterfaceMethodref:
							c="InterfaceMethodref\n";
							break;
						case CONSTANT_NameAndType:
							c="NameAndType       \n";
					}
					lstrcat(res,c);
				}
			}else{
				if(cp->value.u2>param)cp->value.u2--;
				if(cp->value1.u2>param)cp->value1.u2--;
			}
		}

	}


	// fields
	for(i=0;i<str->fields_count;i++){
		field_info* ft=&str->fields[i]; 
		if(func==1){
			if(ft->name_index==param || ft->descriptor_index==param){
				reslen+=str->constant_pool[ft->name_index].value.u2+8;
				res=(char*)HeapReAlloc(heap,0,res,reslen);
				lstrcat(res,"Field: ");
				lstrcpyn(res+(reslen-str->constant_pool[ft->name_index].value.u2-2),(char*)(str->constant_pool[ft->name_index].value1.string),str->constant_pool[ft->name_index].value.u2+1);
				lstrcat(res,"\n");
			}
		}else{
			if(ft->name_index>param)ft->name_index--; 
			if(ft->descriptor_index>param)ft->descriptor_index--; 
		}

		if(ft->attributes_count>0){
			lstrcpy(buff,"Field: ");
			lstrcpyn(buff+7,(char*)(str->constant_pool[ft->name_index].value1.string),str->constant_pool[ft->name_index].value.u2+1);
			char* c=processAttributes(str,ft->attributes,ft->attributes_count,buff,str->constant_pool[ft->name_index].value.u2+7,func,param); 
			if(c){
				reslen+=lstrlen(c);
				res=(char*)HeapReAlloc(heap,0,res,reslen);
				lstrcat(res,c);
				HeapFree(heap,0,c);
			}
		}
	}

	// methods
	for(i=0;i<str->methods_count;i++){
		method_info* mt=&str->methods[i]; 

		if(func==1){
			if(mt->name_index==param || mt->descriptor_index==param){
				reslen+=str->constant_pool[mt->name_index].value.u2+9;
				res=(char*)HeapReAlloc(heap,0,res,reslen);
				lstrcat(res,"Method: ");
				lstrcpyn(res+(reslen-str->constant_pool[mt->name_index].value.u2-2),(char*)(str->constant_pool[mt->name_index].value1.string),str->constant_pool[mt->name_index].value.u2+1);
				lstrcat(res,"\n");
			}
		}else{
			if(mt->name_index>param)mt->name_index--;
			if(mt->descriptor_index>param)mt->descriptor_index--;
		}

		if(mt->attributes_count>0){
			lstrcpy(buff,"Method: ");
			lstrcpyn(buff+8,(char*)(str->constant_pool[mt->name_index].value1.string),str->constant_pool[mt->name_index].value.u2+1);
			char* c=processAttributes(str,mt->attributes,mt->attributes_count,buff,str->constant_pool[mt->name_index].value.u2+8,func,param); 
			if(c){
				reslen+=lstrlen(c);
				res=(char*)HeapReAlloc(heap,0,res,reslen);
				lstrcat(res,c);
				HeapFree(heap,0,c);
			}
		}


	}

	// attributes
	if(str->attributes_count>0){
		lstrcpy(buff,"Class Structure ");
		char* c=processAttributes(str,str->attributes,str->attributes_count,buff,16,func,param); 
		if(c){
			reslen+=lstrlen(c);
			res=(char*)HeapReAlloc(heap,0,res,reslen);
			lstrcat(res,c);
			HeapFree(heap,0,c);
		}
	}

	if(func==1 && reslen==1){
		HeapFree(heap,0,res);
		res=0;
	}

	return res;

}


char* processAttributes(struct classfile* str, attribute_info* attr, int attr_count,char* s,int slen, int func, unsigned int param)
{

	char buff[1024];

	char*  res = 0;
	if(func==1)res=(char*)HeapAlloc(heap,HEAP_ZERO_MEMORY,1);
	int reslen=1;

	for(int i=0;i<attr_count;i++){
		attribute_info* at = &attr[i];
		char* c = (char*)(str->constant_pool[at->attribute_name_index].value1.string); 
		int clen = str->constant_pool[at->attribute_name_index].value.u2;  
		
		if(!CompareMemory(c,clen,"ConstantValue",13)){
			unsigned char* p = at->info;
			unsigned short index = (*p<<8) | (*(p+1));
			if(func==1){
				if(index==param){
					reslen+=slen+26;
					res=(char*)HeapReAlloc(heap,0,res,reslen);
					lstrcat(res,s);
					lstrcat(res," Attribute: ConstantValue\n");
				}
			}else{
				if(index>param){
					index--;
					*p=index>>8;
					*(p+1)=index & 0xFF;
				}
			}
		}else if(!CompareMemory(c,clen,"Code",4)){
			unsigned char* p = at->info+4;
			unsigned long u4 = *(unsigned long*)p;
			invertBytesEx(&u4,4);

			// code
			unsigned __int64* r = processCode(p+4, u4, func, param);
			unsigned __int64* r1=r;
			while(*r1){
				unsigned __int64 num = *r1;
				char* instr = commands[(unsigned long)(num & 0xFF)];
				if(!instr)instr="Unknown";
				reslen+=slen+40+lstrlen(instr);
				res=(char*)HeapReAlloc(heap,0,res,reslen);
				lstrcat(res,s);
				wsprintf(buff," Address: %0.4lX Line: %0.4lX Instruction: %s\n",(unsigned long)((num & 0xFFFFFF00)>>8),(unsigned long)(num>>32),instr);
				lstrcat(res,buff);
				r1++;
			}
			HeapFree(heap,0,r);

			p+=4+u4;
			unsigned short u2 = ((*p)<<8) | (*(p+1));
			p+=8;
			for(int j=0;j<u2;j++){
				unsigned index = ((*p)<<8) | (*(p+1));
				if(index){
					if(func==1){
						if(index==param){
							reslen+=slen+17;
							res=(char*)HeapReAlloc(heap,0,res,reslen);
							lstrcat(res,s);
							lstrcat(res," Attribute: Code\n");
						}
					}else{
						if(index>param){
							index--;
							*p=index>>8;
							*(p+1)=index & 0xFF;
						}
					}
				}
				p+=8;
			}
			p-=6;
			
			// attributes
			u2 = ((*p)<<8) | (*(p+1));
			p+=2;
			for(j=0;j<u2;j++){
				unsigned index = ((*p)<<8) | (*(p+1));
				char* c = (char*)(str->constant_pool[index].value1.string);
				int clen = str->constant_pool[index].value.u2;  
				
				if(func==1){
					if(index==param){
						reslen+=slen+19+str->constant_pool[index].value.u2;
						res=(char*)HeapReAlloc(heap,0,res,reslen);
						lstrcat(res,s);
						lstrcat(res," Attribute: Code->");
						lstrcat(res,c);
						lstrcat(res,"\n");
					}
				}else{
					if(index>param){
						index--;
						*p=index>>8;
						*(p+1)=index & 0xFF;
					}
				}

				p+=2;
				unsigned long u4 = *(unsigned long*)p;
				invertBytesEx(&u4,4);
				p+=4;

				if(!CompareMemory(c,clen,"LocalVariableTable",18)){
					unsigned short count = (*p<<8) | (*(p+1));	
					p+=6;
					for(int k=0;k<count;k++){
						for(int l=0;l<2;l++){
							index = (*p<<8) | (*p+1);
							if(func==1){
								if(index==param){
									reslen+=slen+37;
									res=(char*)HeapReAlloc(heap,0,res,reslen);
									lstrcat(res,s);
									lstrcat(res," Attribute: Code->LocalVariableTable\n");
								}
							}else{
								if(index>param){
									index--;
									*p=index>>8;
									*(p+1)=index & 0xFF;
								}
							}
							p+=2;
						}
						p+=4;
					}
					p-=4;
				}else if(!CompareMemory(c,clen,"LineNumberTable",15)){
					p+=u4;
				}
			}
		}else if(!CompareMemory(c,clen,"Exceptions",10)){
			unsigned char* p = at->info;
			unsigned short u2 = (*p<<8) | (*(p+1));
			p+=2;
			for(int i=0;i<u2;i++){
				unsigned short index = (*p<<8) | (*(p+1));
				if(func==1){
					if(index==param){
						reslen+=slen+23;
						res=(char*)HeapReAlloc(heap,0,res,reslen);
						lstrcat(res,s);
						lstrcat(res," Attribute: Exceptions\n");
					}
				}else{
					if(index>param){
						index--;
						*p=index>>8;
						*(p+1)=index & 0xFF;
					}
				}
				p+=2;
			}
		}else if(!CompareMemory(c,clen,"InnerClasses",12)){
			unsigned char* p = at->info;
			unsigned short u2 = (*p<<8) | (*(p+1));
			p+=2;
			for(int i=0;i<u2;i++){
				for(int j=0;j<3;j++){
					unsigned short index = (*p<<8) | (*(p+1));
					if(index){
						if(func==1){
							if(index==param){
								reslen+=slen+25;
								res=(char*)HeapReAlloc(heap,0,res,reslen);
								lstrcat(res,s);
								lstrcat(res," Attribute: InnerClasses\n");
							}
						}else{
							if(index>param){
								index--;
								*p=index>>8;
								*(p+1)=index & 0xFF;
							}
						}
					}
					p+=2;
				}
				p+=2;
			}
		}else if(!CompareMemory(c,clen,"SourceFile",10)){
			unsigned char* p = at->info;
			unsigned short index = (*p<<8) | (*(p+1));
			if(func==1){
				if(index==param){
					reslen+=slen+26;
					res=(char*)HeapReAlloc(heap,0,res,reslen);
					lstrcat(res,s);
					lstrcat(res," Attribute: SourceFile\n");
				}
			}else{
				if(index>param){
					index--;
					*p=index>>8;
					*(p+1)=index & 0xFF;
				}
			}
		}
		

		if(func==1){
			if(at->attribute_name_index==param){
					int offset=reslen+slen+11;
					reslen+=slen+13+(str->constant_pool[at->attribute_name_index].value.u2);
					res=(char*)HeapReAlloc(heap,0,res,reslen);
					lstrcat(res,s);
					lstrcat(res," Attribute: ");
					lstrcpyn(res+offset,c,str->constant_pool[at->attribute_name_index].value.u2+1);
					lstrcat(res,"\n");
			}
		}else{
			if(at->attribute_name_index>param)at->attribute_name_index--;
		}
	}

	if(func==1 && reslen==1){
		HeapFree(heap,0,res);
		res=0;
	}


	return res;	

}


/*
func:	1 - search for references, param - const. index
		2 - subtract 1 from all constants with indexes g.t. param
*/
unsigned __int64* processCode(unsigned char* code, unsigned int len, int func, int param)
{
	
	unsigned char* code0 = code;		

	unsigned __int64* res=(unsigned __int64*)HeapAlloc(heap,HEAP_ZERO_MEMORY,10*8);
	long reslen=10;
	long respos=0;

	unsigned __int64 pos=0;
	unsigned __int64 bpos = 0;
	unsigned char ct;
	unsigned long low, high;
	unsigned char opcode;

	for(;;){
		
		// instructions refering to constant pool
		opcode=*code;
		switch(opcode){
		case 0x12: // ldc
			ct=*(code+1);
			if(func==1){
				if(ct==param){
					if(reslen-respos<=1){
						reslen+=10;
						res=(unsigned __int64*)HeapReAlloc(heap,HEAP_ZERO_MEMORY,res,reslen);
					}
					res[respos]=(pos<<32)|(bpos<<8)|0x12;
					respos++;
				}
			}else{
				if(ct>param)*(code+1)=ct-1;
			}
			break;
		case 0x13: // ldc_w
		case 0x14: // ldc2_w
		case 0xb2: // getstatic
		case 0xb3: // putstatic 
		case 0xb4: // getfield
		case 0xb5: // putfield
		case 0xb6: // invokevirtual
		case 0xb7: // invokespecial
		case 0xb8: // invokestatic
		case 0xb9: // invokeinterface
		case 0xbb: // new
		case 0xbd: // anewarray
		case 0xc0: // checkcast
		case 0xc1: // instanceof
		case 0xc5: // multianewarray
			unsigned short index=(*(code+1)<<8) | (*(code+2));
			if(func==1){
				if(index==param){
					if(reslen-respos<=1){
						reslen+=10;
						res=(unsigned __int64*)HeapReAlloc(heap,HEAP_ZERO_MEMORY,res,reslen);
					}
					res[respos]=(pos<<32)|(bpos<<8)|opcode;
					respos++;
				}
			}else{
				if(index>param){
					index--;
					*(code+1)=index>>8;
					*(code+2)=index & 0xFF;
				}
			}
		}
		
		//  take care of operands
		char c = operands[*code];
		if(c>0){
			code+=c;
		} else if(c==-1){ // variable-length instructions
			switch(opcode){
			case 0xAA: // tableswitch
			case 0xAB: // lookupswitch
				code+=5+(4-(bpos+1)%4)%4;
				low=*(unsigned long*)(code);
				invertBytesEx(&low,4);
				if(opcode==0xAA){				
					high=*(unsigned long*)(code+4);
					invertBytesEx(&high,4);
					code+=(high-low+3)*4;
				} else {
					code+=low*8;
				}
				break;
			case 0xC4: // wide
				code+=((*(code+1)==0x84)?5:3); // 0x84: iinc
			}
		}

		if(bpos==len-1)break;
		code++;
		pos++;
		bpos=code-code0;
	}

	
	return res;
}


int CompareMemory (
        const void * buf1,
		size_t count1,
        const void * buf2,
        size_t count2
        )
{
        if (!count1 && !count2)
                return(0);

        while ( --count1 && --count2 && *(char *)buf1 == *(char *)buf2 ) {
                buf1 = (char *)buf1 + 1;
                buf2 = (char *)buf2 + 1;
        }

        return( *((unsigned char *)buf1) - *((unsigned char *)buf2) );
}
