
/*
    cp_info {
    	u1 tag;
    	u1 info[];
    }
*/

struct cp_info{
	unsigned char tag;
	union union1{
		unsigned short		u2;
		unsigned long		u4;
		unsigned __int64	u8;
		double				d;
		float				f;
	} value;

	union union2{
		unsigned short		u2;
	    unsigned char *string;
	} value1;
};


/*
    attribute_info {
    	u2 attribute_name_index;
    	u4 attribute_length;
    	u1 info[attribute_length];
    }
*/

struct attribute_info {
    unsigned short attribute_name_index;
    unsigned long attribute_length;
    unsigned char *info;
};


/*
		field_info {
    		u2 access_flags;
    		u2 name_index;
    		u2 descriptor_index;
    		u2 attributes_count;
    		attribute_info attributes[attributes_count];
		}
*/

struct field_info {
    unsigned short access_flags;
    unsigned short name_index;
    unsigned short descriptor_index;
    unsigned short attributes_count;
    attribute_info *attributes;
};


/*
    method_info {
    	u2 access_flags;
    	u2 name_index;
    	u2 descriptor_index;
    	u2 attributes_count;
    	attribute_info attributes[attributes_count];
    }
*/

struct method_info {
    unsigned short access_flags;
    unsigned short name_index;
    unsigned short descriptor_index;
    unsigned short attributes_count;
    attribute_info *attributes;
};


/*
    ClassFile {
    	u4 magic;
    	u2 minor_version;
    	u2 major_version;
    	u2 constant_pool_count;
    	cp_info constant_pool[constant_pool_count-1];
    	u2 access_flags;
    	u2 this_class;
    	u2 super_class;
    	u2 interfaces_count;
    	u2 interfaces[interfaces_count];
    	u2 fields_count;
    	field_info fields[fields_count];
    	u2 methods_count;
    	method_info methods[methods_count];
    	u2 attributes_count;
    	attribute_info attributes[attributes_count];
    }
*/

struct classfile {
	unsigned long magic;	
    unsigned short minor_version;
    unsigned short major_version;
    unsigned short constant_pool_count;
    cp_info *constant_pool;
    unsigned short access_flags;
    unsigned short this_class;
    unsigned short super_class;
    unsigned short interfaces_count;
    unsigned short *interfaces;
    unsigned short fields_count;
    field_info *fields;
    unsigned short methods_count;
    method_info *methods;
    unsigned short attributes_count;
    attribute_info *attributes;
};



void writeClassToFile(HANDLE hFile, struct classfile str);
struct classfile parseClassFromFile(HANDLE hFile);
void freeClassStruct(struct classfile mainstr);
void invertBytesEx(void* v, DWORD len);
BOOL ReadFileBigEndian(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped);
BOOL WriteFileBigEndian(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped);
void parseAttributes(HANDLE hFile, attribute_info** attr, int attr_count);
void writeAttributes(HANDLE hFile, attribute_info* attr, int attr_count);




char* processClassStruct(struct classfile* str, int func, int param);
char* deleteConstant(struct classfile* str, unsigned long index, int* ret);
void splitMethods(struct classfile* str);
void restoreMethods(struct classfile* str);



#define CONSTANT_Utf8				1
#define CONSTANT_Integer			3
#define CONSTANT_Float				4
#define CONSTANT_Long				5
#define CONSTANT_Double				6
#define CONSTANT_Class				7
#define CONSTANT_String				8
#define CONSTANT_Fieldref			9
#define CONSTANT_Methodref			10
#define CONSTANT_InterfaceMethodref	11
#define CONSTANT_NameAndType		12
