
//#define	_WIN32_WINNT	0x0500 
#define	WINVER			0x0500


#include <windows.h>
//#include <stdio.h>
//#include <fstream>
#include <commctrl.h>
#include "classparser.h"


#define TVM_GETITEMSTATE        (TV_FIRST + 39)

LRESULT CALLBACK WindowProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK WindowProcMain(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK MenuWindowProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
BOOL CALLBACK EnumThreadWndProc(HWND hwnd,LPARAM lParam);
LRESULT CALLBACK MenuProc(int nCode,WPARAM wParam,LPARAM lParam);

void AddMainMenu();
long GetSelectedTreeViewRoot(int* pos);
long GetTreeViewRoot(char* caption);
int HexToInt(char* s, int len);
char* getSelectedClassFile();
struct classfile readClassFile(char* file);

HINSTANCE hInstance=NULL;

HHOOK hWinHook = 0;
HHOOK hMenuHook = NULL;

HWND hMain=NULL;
HWND hListView=NULL;
HWND hTreeView=NULL;
HWND hEditor=NULL;

long lOldWinHandle=0;
long lOldWinHandleMain=0;
long lOldMenuWinHandle=0;

HMENU hMainMenu = NULL; 
UINT idReloadClassMenu = 0;
UINT idSaveClassMenu = 0;
UINT idRemoveClassMenu = 0;

long lLines=0;
long lCols=0;

//FILE* f=NULL;

bool bPopupCreated = false;

int iPopupMenuClicked = 0;

HANDLE heap = NULL;

char filebuff[266];

LPARAM REMOTE_LOADLIBRARY = (LPARAM)12345;
LPARAM REMOTE_SETHWND = (LPARAM)12346;

BOOL WINAPI DllMain(
  HANDLE hinstDLL,  // handle to the DLL module
  DWORD fdwReason,     // reason for calling function
  LPVOID lpvReserved   // reserved
)

{
	switch(fdwReason){
	case DLL_PROCESS_ATTACH:
		{
			hInstance=(HINSTANCE)hinstDLL;
		}
		break;
	case DLL_PROCESS_DETACH:
		break;
	}

	return TRUE;

}


//The CBT hook Proc(Computer Based Training Hook)
LRESULT CALLBACK CBTProc(int nCode,WPARAM wParam,LPARAM lParam)
{
	
	if(nCode==HCBT_SYSCOMMAND && lParam==REMOTE_SETHWND){ 
		hMain=(HWND)wParam;

	}else if(nCode==HCBT_SYSCOMMAND && lParam==REMOTE_LOADLIBRARY){ 
	    EnumThreadWindows(GetCurrentThreadId(), EnumThreadWndProc, (LPARAM)0);	

		if(hMain!=NULL){
			HWND hTemp = FindWindowEx(hMain,NULL,"AfxMDIFrame42s",NULL);
			hListView=FindWindowEx(hTemp,NULL,"SysListView32",NULL);
			hTreeView=FindWindowEx(hTemp,NULL,"SysTreeView32",NULL);

			long style = GetWindowLong(hTreeView, GWL_STYLE);
			SetWindowLong(hTreeView, GWL_STYLE, style | TVS_SHOWSELALWAYS);
			style = GetWindowLong(hListView, GWL_STYLE);
			SetWindowLong(hListView, GWL_STYLE, style | LVS_SHOWSELALWAYS);

			lOldWinHandle=SetWindowLong(hListView,GWL_WNDPROC,(long)WindowProc);
			lOldWinHandleMain=SetWindowLong(hMain,GWL_WNDPROC,(long)WindowProcMain);
			AddMainMenu();
		}

		LoadLibrary("jbhook.dll");
	}

	return CallNextHookEx(NULL, nCode, wParam, lParam);
}//End of the hook procedure


void AddMainMenu() {

	HMENU hm = CreatePopupMenu();
	AppendMenu(hm,MF_STRING | MF_ENABLED,1000,"Unique names for overloaded functions");
	AppendMenu(hm,MF_STRING | MF_ENABLED,1001,"Restore overloaded function names");
	
	HMENU menu = GetMenu(hMain);

	HMENU subm = GetSubMenu(menu,2);
	idRemoveClassMenu=GetMenuItemID(subm,1);
	idReloadClassMenu=GetMenuItemID(subm,3);
	idSaveClassMenu=GetMenuItemID(subm,6);

	InsertMenu(menu,GetMenuItemCount(menu)-1,MF_STRING | MF_POPUP | MF_ENABLED | MF_BYPOSITION, (unsigned int)hm, "Functions");
	DrawMenuBar(hMain);
	hMainMenu=hm;

	heap=GetProcessHeap();


}


BOOL CALLBACK EnumThreadWndProc(
  HWND hwnd,      // handle to window
  LPARAM lParam   // application-defined value
  )

{
	if(IsWindowVisible(hwnd)){
		hMain=hwnd;
		return FALSE;
	}
	return TRUE;
}



LRESULT CALLBACK WindowProcMain(
  HWND hwnd,
  UINT uMsg,
  WPARAM wParam,
  LPARAM lParam
)
{	

	long lResult = 0;

	switch(uMsg){
	case WM_INITMENUPOPUP:
		if(wParam==(UINT)hMainMenu){
			long item = GetSelectedTreeViewRoot(NULL);
			UINT state; 
			if(item){
				state=MFS_ENABLED;	
			} else {
				state=MFS_DISABLED;
			}
			MENUITEMINFO mn;
			mn.cbSize=sizeof(mn);
			mn.fMask=MIIM_STATE;
			mn.fState=state;

			SetMenuItemInfo(hMainMenu,0,TRUE,&mn);
			SetMenuItemInfo(hMainMenu,1,TRUE,&mn);
			return 0;
		}
		break;
	case WM_COMMAND:
		if((wParam>>16)==0){
			unsigned int lowWord = wParam & 0xFFFF;
			if(lowWord==1000 || lowWord==1001){
				int msg = MessageBox(hMain,"Selected class will be reloaded. Save changes?","Split function names",MB_YESNOCANCEL);
				if(msg!=IDCANCEL){
					char* file = getSelectedClassFile();

					if(msg==IDYES){
						SendMessage(hMain,WM_COMMAND,(WPARAM)idSaveClassMenu,NULL);
					}

					struct classfile mainstr = readClassFile(file);

					if(lowWord==1000){
						splitMethods(&mainstr);
					} else {
						restoreMethods(&mainstr);
					}


					DWORD attr = GetFileAttributes(file);
					if(attr & FILE_ATTRIBUTE_READONLY)SetFileAttributes(file, attr & 0xFFFFFFFE);

					HANDLE hFileTo = CreateFile(file,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

					writeClassToFile(hFileTo, mainstr);
					CloseHandle(hFileTo);
					if(attr & FILE_ATTRIBUTE_READONLY)SetFileAttributes(file, attr);

					freeClassStruct(mainstr);
					
					SendMessage(hMain,WM_COMMAND,(WPARAM)idReloadClassMenu,NULL);
			}

			} else if(lowWord==idReloadClassMenu) {
				char* file = getSelectedClassFile();
				lResult=CallWindowProc((WNDPROC)lOldWinHandleMain,hwnd,uMsg,wParam,lParam);
				long item=GetTreeViewRoot(file);
				if(item){
					SendMessage(hTreeView,TVM_SELECTITEM,TVGN_CARET,item);
					SendMessage(hTreeView,TVM_EXPAND,TVE_EXPAND,item);
				}
				return lResult;
			} else if(lowWord==idRemoveClassMenu) {

				int pos;
				GetSelectedTreeViewRoot(&pos);
				lResult=CallWindowProc((WNDPROC)lOldWinHandleMain,hwnd,uMsg,wParam,lParam);

				long res = SendMessage(hTreeView, TVM_GETNEXTITEM, TVGN_ROOT, 0);
				long lastres = res;
				while(res && pos--){
					lastres=res;
					res = SendMessage(hTreeView, TVM_GETNEXTITEM, TVGN_NEXT, res);
				}
				if(lastres){
					if(!res)res=lastres;
					if(res){
						SendMessage(hTreeView,TVM_SELECTITEM,TVGN_CARET,res);
					}
				}


				return lResult;
			}
		}
	}

	lResult=CallWindowProc((WNDPROC)lOldWinHandleMain,hwnd,uMsg,wParam,lParam);
	return lResult;

}

LRESULT CALLBACK WindowProc(
  HWND hwnd,
  UINT uMsg,
  WPARAM wParam,
  LPARAM lParam
)
{	

	switch(uMsg){
	case WM_CONTEXTMENU:
		if(hMenuHook){
			if(iPopupMenuClicked){
				int msg = 0;
				if(iPopupMenuClicked==1){  // Delete
					msg = MessageBox(hMain,"Selected class will be reloaded. Save changes?","Delete Constant",MB_YESNOCANCEL);
				}
				if(iPopupMenuClicked==2 || msg!=IDCANCEL){

					char buff[266];

					int ind = SendMessage(hListView,LVM_GETNEXTITEM,(WPARAM)-1,MAKELPARAM((UINT) LVNI_SELECTED, 0));
					LVITEM lv;
					lv.iSubItem=0;
					lv.pszText=buff; 
					lv.cchTextMax=266;
					SendMessage(hListView,LVM_GETITEMTEXT,(WPARAM)ind,(LPARAM)&lv);
					int IDX = HexToInt(lv.pszText,4);
					
					char* file = getSelectedClassFile();

					if(iPopupMenuClicked==1 && msg==IDYES){
						SendMessage(hMain,WM_COMMAND,(WPARAM)idSaveClassMenu,NULL);
					}


					struct classfile mainstr = readClassFile(file);

					char* res = 0;
					int ret = 0;
					if(iPopupMenuClicked==1){
						res = deleteConstant(&mainstr, IDX, &ret);
					}else{
						res = processClassStruct(&mainstr, 1, IDX);
					}

					if(res){
						int len = lstrlen(res);
						char* message = (char*)HeapAlloc(heap,0,len+((iPopupMenuClicked==1)?((ret==0)?60:0):38));
						if(iPopupMenuClicked==1){
							if(!ret){
								lstrcpy(message,"Selected constant cannot be deleted. It is referenced by:\n\n");
							} else {
								*message=0;
							}
						} else {
							lstrcpy(message,"Selected constant is referenced by:\n\n");
						}
						lstrcat(message,res);
						MessageBox(hMain,message,"JavaBite",MB_OK);
						HeapFree(heap,0,res);
						HeapFree(heap,0,message);
					} else {
						if(iPopupMenuClicked==1){

							DWORD attr = GetFileAttributes(file);
							if(attr & FILE_ATTRIBUTE_READONLY)SetFileAttributes(file, attr & 0xFFFFFFFE);

							HANDLE hFileTo = CreateFile(file,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

							writeClassToFile(hFileTo, mainstr);
							CloseHandle(hFileTo);
							if(attr & FILE_ATTRIBUTE_READONLY)SetFileAttributes(file, attr);
							freeClassStruct(mainstr);
							
							SendMessage(hMain,WM_COMMAND,(WPARAM)idReloadClassMenu,NULL);
							long item = GetSelectedTreeViewRoot(NULL);
							item=SendMessage(hTreeView,TVM_GETNEXTITEM,TVGN_CHILD,item);
							SendMessage(hTreeView,TVM_SELECTITEM,TVGN_CARET,item);
						} else {
							MessageBox(hMain,"No references found.","JavaBite",MB_OK);
						}
					}
				}

				iPopupMenuClicked=0;
			}

			UnhookWindowsHookEx(hMenuHook);
			hMenuHook=NULL;
		}
		bPopupCreated = false;
		break;
	case WM_RBUTTONDOWN:
		if(wParam & MK_RBUTTON){
	        hMenuHook = SetWindowsHookEx(WH_CALLWNDPROC, MenuProc, NULL, GetCurrentThreadId());
		}
	}
	
	long lResult=CallWindowProc((WNDPROC)lOldWinHandle,hwnd,uMsg,wParam,lParam);
	return lResult;
}



LRESULT CALLBACK MenuProc(
  int nCode,      // hook code
  WPARAM wParam,  // current-process flag
  LPARAM lParam   // message data
  )
{
	CWPSTRUCT *cwp = (CWPSTRUCT*)lParam;

	switch(cwp->message){
	case WM_CREATE:
       
		bPopupCreated = true;

		lOldMenuWinHandle = SetWindowLong(cwp->hwnd, GWL_WNDPROC, (long)MenuWindowProc);
	
		if(hMenuHook)UnhookWindowsHookEx(hMenuHook);


		break;
	}
	
	return CallNextHookEx(hMenuHook, nCode, wParam, lParam);

}

LRESULT CALLBACK MenuWindowProc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
    MENUBARINFO pm; 

	switch(uMsg){
	case WM_DESTROY:
		SetWindowLong(hwnd, GWL_WNDPROC, (long)lOldMenuWinHandle);
		break;
	case 0x1E2:
		if(bPopupCreated){
		    pm.cbSize = sizeof(pm);
            GetMenuBarInfo(hwnd, OBJID_CLIENT, 0, &pm);

			bool b=false;
			int count = GetMenuItemCount(pm.hMenu);
			if(count==2){
				char buffer[24];
				GetMenuString(pm.hMenu,0,buffer,24,MF_BYPOSITION);

				if(lstrcmp(buffer,"Edit")==0){
					GetMenuString(pm.hMenu,1,buffer,24,MF_BYPOSITION);

					if(lstrcmp(buffer,"New Constant Pool Entry")==0){
						InsertMenu(pm.hMenu,1,MF_STRING | MF_ENABLED | MF_BYPOSITION,1002,"Delete");
						InsertMenu(pm.hMenu,2,MF_STRING | MF_ENABLED | MF_BYPOSITION,1002,"References");
						b=true;
					}
				}


			}

			bPopupCreated = false;
			if(!b)SetWindowLong(hwnd, GWL_WNDPROC, (long)lOldMenuWinHandle);
		}
		break;
	case 0x1EF:
		if(wParam==1){ // Delete
			iPopupMenuClicked=1;
		} else if(wParam==2){ // References
			iPopupMenuClicked=2;
		}
		break;
	}

	return CallWindowProc((WNDPROC)lOldMenuWinHandle,hwnd,uMsg,wParam,lParam);



}


long GetSelectedTreeViewRoot(int* pos) {

	long res = SendMessage(hTreeView, TVM_GETNEXTITEM, TVGN_ROOT, 0);
	if(pos)*pos=0;

	while(res){
		if(SendMessage(hTreeView, TVM_GETITEMSTATE, res, TVIS_BOLD) & TVIS_BOLD)break;
		res = SendMessage(hTreeView, TVM_GETNEXTITEM, TVGN_NEXT, res);
		if(pos)(*pos)++;
	}

	return res;

}

long GetTreeViewRoot(char* caption) {

	long res = SendMessage(hTreeView, TVM_GETNEXTITEM, TVGN_ROOT, 0);
	char buff[266];

	TVITEM it;
	it.mask=TVIF_TEXT;
	it.pszText=buff; 
	it.cchTextMax=266;

	while(res){
		it.hItem=(HTREEITEM)res;
		SendMessage(hTreeView,TVM_GETITEM,0,(LPARAM)&it);
		if(lstrcmp(caption,it.pszText)==0)break;
		res = SendMessage(hTreeView, TVM_GETNEXTITEM, TVGN_NEXT, res);
	}

	return res;

}


int HexToInt(char* s, int len){
	int res=0;
	char c;
	bool b=false;

	while(len--){
		c=*s;
		if(b || c!='0'){
			res=res*16;
			if(c>='0' && c<='9')res+=c-'0';
			if(c>='A' && c<='F')res+=c-'A'+10;
			b=true;
		}
		s++;
	}
	return res;
}

char* getSelectedClassFile() {

	TVITEM it;
	it.mask=TVIF_TEXT;
	it.pszText=filebuff; 
	it.cchTextMax=266;

	long item = GetSelectedTreeViewRoot(NULL);
	it.hItem=(HTREEITEM)item;
	SendMessage(hTreeView,TVM_GETITEM,0,(LPARAM)&it);
	return it.pszText;
}

struct classfile readClassFile(char* file){
	
	HANDLE hFileFrom = CreateFile(file,GENERIC_READ,NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	struct classfile mainstr = parseClassFromFile(hFileFrom);
	CloseHandle(hFileFrom);
	return mainstr;

}